//********************************************************************************************
// 2 DOF - SimTools to Ard. 
// code By EAOROBBIE (Robert Lindsay)
// Thanks to aarondc for layout from RC Model code help. 
// For free use for Sim Tool Motion Software
//********************************************************************************************
#define DEBUG 1                                    // comment out this line to remove debuggin Serial.print lines
const int kAxisCount = 2;                          // how many axis we are handling


const char kAxisName[kAxisCount] = { 'R', 'P'};    // the letters ("names") sent from Sim Tools to identify each axis
const char kEOL = '~';                             // End of Line - the delimiter for our acutator values 
const int kMaxCharCount = 5;                       // some insurance to 16 bit...
int axisPosition[kAxisCount] = {127, 127};         // current Axis positions, initialised to 127 middle for 8 bit
int currentAxis;                                   // keep track of the current Axis being read in from serial port
int valueCharCount = 0;                            // how many value characters have we read (must be less than kMaxCharCount!!

// set up some states for our state machine
// psReadAxis = next character from serial port tells us the Axis info that follows
// psReadValue = next characters from serial port until we hit our kMaxCharCount or kEOL which tells us the value
enum TPortState { psReadAxis, psReadValue };   
TPortState currentState = psReadAxis;

void setup()
{ 
    
    Serial.begin(9600); // opens serial port at a baud rate of 9600
} 
 
void loop()
{ 

}

// this code only runs when we have serial data available. ie (Serial.available() > 0).
void serialEvent() {
    char tmpChar;
    int tmpValue;

    while (Serial.available()) {
        // if we're waiting for a Axis name, grab it here
        if (currentState == psReadAxis) {
            tmpChar = Serial.read();
            
#ifdef DEBUG            
Serial.print("read in ");            
Serial.println(tmpChar);            
#endif
        for (int i = 0; i < kAxisCount; i++) {    // look for our axis in the array of axis names we set up
        if (tmpChar == kAxisName[i]) {
#ifdef DEBUG            
Serial.print("which is axis ");            
Serial.println(i);            
#endif
                    currentAxis = i;                            // remember which axis we found
                    currentState = psReadValue;                 // start looking for the Axis position 
                    axisPosition[currentAxis] = 0;              // initialise the new position
                    valueCharCount = 0;                         // initialise number of value chars read in 
                    break;
                }
            }
        }
        
        // if we're ready to read in the current Axis position data
        if (currentState == psReadValue) {
            while ((valueCharCount < kMaxCharCount) && Serial.available()) {
                tmpValue = Serial.read();
                if (tmpValue != kEOL) {
                    tmpValue = tmpValue - 48;
                    if ((tmpValue < 0) || (tmpValue > 9)) tmpValue = 0;
                    axisPosition[currentAxis] = axisPosition[currentAxis] * 10 + tmpValue;
                    valueCharCount++;
                }
                else break;
            }
            
            // if we've read the value delimiter, update the Axis and start looking for the next Axis name
            if (tmpValue == kEOL || valueCharCount == kMaxCharCount) {
#ifdef DEBUG            
Serial.print("read in ");            
Serial.println(axisPosition[currentAxis]);            
#endif
                
                currentState = psReadAxis;
            }
        }
    }
}



